
-- # import prop

data TC {A:Set}(R:A -> A -> Set) : A -> A -> Set where
  tcrefl (a:A)	   : TC R a a
  tccons (a,b,c:A) : R a b -> TC R b c -> TC R a c

tcunit (A:Set)(R:A -> A -> Set)(a,b:A) : R a b -> TC R a b
tcunit r = tccons r tcrefl

tctrans (A:Set)(R:A -> A -> Set)(s,t,u:A) : TC R s t -> TC R t u -> TC R s u
tctrans tcrefl	       r = r
tctrans (tccons r1 r2) r = tccons r1 (tctrans r2 r)

infixr 10 `tccons`, `tccons'`

tccons' (A:Set)(R:A -> A -> Set)(s,t,u:A) : R s t -> TC R t u -> TC R s u
tccons' r tr = tccons r tr

LocalConfluence (A:Set) : (A -> A -> Set) -> Set
LocalConfluence {A} R =
  (u, u1, u2 : A)      ->
  R u u1 -> R u u2 ->
  { v : A; TC R u1 v /\ TC R u2 v }

Confluence (A:Set) : (A -> A -> Set) -> Set
Confluence {A} R =
  (u, u1, u2 : A)        ->
  TC R u u1 -> TC R u u2 ->
  { v : A; TC R u1 v /\ TC R u2 v }

X : Set
(-->) : X -> X -> Set

localConfluence : LocalConfluence (-->)

confluence : Confluence (-->)

confluence u u  u   tcrefl	  tcrefl	= (u, andI tcrefl tcrefl)
confluence u u' u  (tccons r tr)  tcrefl	= (u', andI tcrefl (tccons' r tr))
confluence u u  u'  tcrefl	 (tccons r tr)	= (u', andI (tccons' r tr) tcrefl)

confluence u u1 u2 (tccons r1 tr1) (tccons r2 tr2)
		   with localConfluence u _ _ r1 r2 =>
  u u1 u2 (tccons r1 tr1) (tccons r2 tr2) (v, andI tr1' tr2')
		   with confluence _ v u2 tr2' tr2 =>
    u u1 u2 (tccons r1 tr1) (tccons r2 tr2) (v, andI tr1' tr2') (v', andI tr2a tr2b)
		   with confluence _ u1 v' tr1 (tctrans tr1' tr2a) =>
      u u1 u2 (tccons r1 tr1) (tccons r2 tr2) (v, andI tr1' tr2')
					      (v', andI tr2a tr2b)
					      (v'', andI tr1a tr2c)
	= (v'', andI tr1a (tctrans tr2b tr2c))

