
-- # import nat

-- Inequality relation on natural numbers.
data (=/=) : Nat -> Nat -> Set where
  uneqZS (n : Nat)   : zero  =/= suc n
  uneqSZ (n : Nat)   : suc n =/= zero
  uneqSS (n,m : Nat) : n =/= m -> suc n =/= suc m

data NatCmp : Nat -> Nat -> Set where
  sameNat	(n : Nat)    : NatCmp n n
  diffNats (n, m : Nat) : n =/= m -> NatCmp n m

natCmp : (n, m : Nat) -> NatCmp n m
natCmp 0 0	 = sameNat
natCmp (suc n) 0 = diffNats uneqSZ
natCmp 0 (suc n) = diffNats uneqZS
natCmp (suc n) (suc m) with natCmp n m =>
  (suc n) (suc n) sameNat	      = sameNat
  (suc n) (suc m) (diffNats neq) = diffNats (uneqSS neq)


