
-- # import id

-- Types ------------------------------------------------------------------

infixr 10 ==>

data Typ : Set where
  nat	: Typ
  (==>) : Typ -> Typ -> Typ

-- Comparing types --------------------------------------------------------

infix 5 =/=

data (=/=) : Typ -> Typ -> Set where
  notFunctionR (s,t : Typ)	  : (s ==> t) =/=  nat
  notFunctionL (s,t : Typ)	  : nat =/= (s ==> t)
  differentArg (s,s',t : Typ)	  : s =/= s' ->
				    (s ==> t) =/= (s' ==> t)
  differentRes (s,t,t' : Typ)	  : t =/= t' ->
				    (s ==> t) =/= (s ==> t')
  allDifferentFun (s,s',t,t' : Typ) : s =/= s' -> t =/= t' ->
				    (s ==> t) =/= (s' ==> t')

data CompareType : Typ -> Typ -> Set where
  same (t : Typ)	      : CompareType t t
  different (s,t : Typ) : s =/= t -> CompareType s t

compareType : (s, t : Typ) -> CompareType s t
compareType nat nat	  = same
compareType (s ==> t) nat = different notFunctionR
compareType nat (s ==> t) = different notFunctionL
compareType (s ==> t) (s' ==> t') with compareType s s', compareType t t' =>
  (s ==> t) (s  ==> t)   same	        same	      = same
  (s ==> t) (s' ==> t ) (different d)   same	      = different (differentArg d)
  (s ==> t) (s  ==> t')  same	       (different d)  = different (differentRes d)
  (s ==> t) (s' ==> t') (different d1) (different d2) = different (allDifferentFun d1 d2)

compareTypeComplete : (s : Typ) -> compareType s s == same
compareTypeComplete nat = refl
compareTypeComplete (s ==> t) =
    rewrite compareTypeComplete s
	    compareTypeComplete t
    in refl
