
-- Monads

sig Monad (m : Set -> Set) : Type where
  return (a : Set) : a -> m a
  bind (a,b : Set) : m a -> (a -> m b) -> m b

liftM (m : Set -> Set)(a,b : Set) : (mon : Monad m) -> (a -> b) -> m a -> m b
liftM mon f m =
  mon.do  x <- m
	  mon.return (f x)

liftM2 (m : Set -> Set)(a,b,c : Set) : (mon : Monad m) -> (a -> b -> c) -> m a -> m b -> m c
liftM2 mon f m1 m2 =
  mon.do  x <- m1
	  y <- m2
	  mon.return $ f x y

