{-| Functions for computing values and unfolding constants. This module
    is growing too large. Should be split into smaller modules.
-}

module TypeChecker.Computation where

import Control.Monad	    ( zipWithM, mplus )

import Syntax.Position
import Syntax.Internal

import TypeChecker.Context
import TypeChecker.Substitution
import TypeChecker.Monad
import TypeChecker.Monad.Context
import TypeChecker.Terms
import TypeChecker.Universes
import TypeChecker.UnfoldConstants
import TypeChecker.Values

import Utils.Map
import Utils.Monads
import Utils.Pairs

import Utils.Debug

-- Evaluating typed terms

evaluateTypedTerm :: TypedTerm -> TC Value
evaluateTypedTerm e = evaluateTypedTerm' <$> getContext <*> return e

evaluateTypedTerm' :: Context -> TypedTerm -> Value
evaluateTypedTerm' ctx = eval (contextToSubst ctx)
    where
	contextToSubst ctx = buildMap [ (x,v) | (x, Defined v) <- assocsMap ctx ]
	eval rho e =
	    case e of
		App e e'	    -> evalr e `vApp` evalr e'
		Var x t		    -> lookupSubst x t rho
		Def x d		    -> VDef x d
		Prop		    -> VSort VSProp
		Star u		    -> VSort $ VSUniv u

		Lam x e t	    -> VLam (Cl x body) t
		    where
			body = \v -> eval (extendSubst x v rho) e

		Pi x a b t	    -> VPi (evalr a) (Cl x body) t
		    where
			body = \v -> eval (extendSubst x v rho) b

		CallPlugin _ _ v    -> v
		Let ds e	    -> eval (foldl ext rho ds) e
		    where
			ext rho (LocalDef x _ b _) =
			    extendSubst x (eval rho b) rho
	    where
		evalr	= eval rho

