{-# OPTIONS -fglasgow-exts #-}

module Utils.Sugar where

data SugaredView a
	= NatSugar Int
	| ListSugar [a]
	| NoSugar a

data Sugar a = Sugar { isZero :: a -> Bool
		     , isSuc  :: a -> Maybe a
		     , isNil  :: a -> Bool
		     , isCons :: a -> Maybe (a,a)
		     }

sugaredView :: Sugar a -> a -> SugaredView a
sugaredView s v
    | isZero s v		       = NatSugar 0
    | Just w	   <- isSuc s v
    , NatSugar n   <- sugaredView s w  = NatSugar (n + 1)
    | isNil s v			       = ListSugar []
    | Just (w,w')  <- isCons s v
    , ListSugar ws <- sugaredView s w' = ListSugar (w:ws)
    | otherwise			       = NoSugar v

