-- an example from Michael Beeson

-- # import Property

-- some logical axioms

infix 14 *
infix 10 +

Ex : (A : Set) -> (A -> Prop) -> Prop
witness : (A : Set) -> (P : A -> Prop) -> (x : A) -> P x -> Ex A P
elimEx : (A : Set) -> (P : A -> Prop) -> Ex A P -> (C : Prop) -> ((x : A) -> P x -> C) -> C

-- natural numbers

data Nat : Set where
 zero : Nat
 succ : Nat -> Nat

indNat : (P : Nat -> Prop) -> P zero -> ((n : Nat) -> P n -> P (succ n)) -> (x : Nat) -> P x
indNat P a g zero = a
indNat P a g (succ n) = g n (indNat P a g n)

-- general definitions

isRing : (X : Set) -> (X -> X -> X) -> (X -> X -> X) -> (X -> X) -> X -> X -> Prop

isRing R (+) (*) minus Zero One =
 (x : R) -> (y : R) -> (z : R) ->
     (   x + y == y + x
      /\ x + Zero == x
      /\ x + (minus x) == Zero
      /\ x + (y + z) == (x + y) + z
      /\ x * (y + z) == (x * y) + (x * z)
      /\ (y + z)* x  == (y * x) + (z * x)
      /\ x * One == x
      /\ One * x == x
      /\ x * (y * z) == (x * y) * z
     )

isBool : (X : Set) -> (X -> X -> X) -> (X -> X -> X) -> (X -> X) -> X -> X -> Prop

isBool R (+) (*) minus Zero One =
     isRing R (+) (*) minus Zero One 
 /\ ((x : R)-> x * x == x)

-- the example

R : Set
(+) : R -> R -> R
(*) : R -> R -> R
minus : R -> R 
Zero : R
One : R

axR : isBool  R (+) (*) minus Zero One 

lem1 : (x : R) -> Zero == Zero * x
lem1 x = fol-plugin(axR)

thm : (x : R) -> x + x == Zero
thm x = fol-plugin(axR, lem1)

thm1 : (x : R) -> (y : R) -> x * y == y * x
thm1 x y = fol-plugin(axR, thm)
