
data Nat : Set where
  zero : Nat
  suc  : Nat -> Nat

data Bool : Set where
  false : Bool
  true	: Bool

mutual
  even : Nat -> Bool
  even 0	= true
  even (suc n)	= odd n

  odd : Nat -> Bool
  odd 0		= false
  odd (suc n)	= even n

mutual
  data Even : Nat -> Set where
    even0 : Even 0
    evenS (n : Nat) : Odd n -> Even (suc n)
  data Odd : Nat -> Set where
    oddS (n : Nat) : Even n -> Odd (suc n)

mutual
  data U : Set where
    nat : U
    pi  : (u : U) -> (T u -> U) -> U

  T : U -> Set
  T nat	     = Nat
  T (pi a b) = (x : T a) -> T (b x)

